#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct tree tree;

struct tree {

	tree *parent;
	tree *left;
	tree *right;
	
	char *name;
};

tree *create_node (char *num);

tree *add_node (tree *root, tree *new);

tree *find_node (tree *root, char *name);

tree *apply_in_order (tree *root, void (*fn) (tree *root, void *), void *arg); 

tree 
*create_node (char *name) {
	
	tree *new;
	
	new = malloc(sizeof(tree));
	
	new->name = malloc((strlen(name) + 1) * sizeof(char));
	
	new->name = name;
	
	new->left = NULL;
	new->right = NULL;
	
	return new;
}

tree 
*add_node (tree *root, tree *new) {
	
	tree *current;
	
	if (root == NULL)
		return new;
	
	current = root;
	
	while (1) {
			
		if ((strcmp(current->name, new->name)) < 0) {
		
			if (current->left == NULL) {
				current->left = new;
				break;
			} else
				current = current->left;
		}
		
		else if ((strcmp(current->name, new->name)) > 0) {
			
			if (current->right == NULL) {
				current->right = new;
				break;
			} else
				current = current->right;
		}
		else if ((strcmp(current->name, new->name)) == 0) {
			
			printf("such data already exist\n");
			break;
		}
	}
	
	return root;
}

tree 
*find_node (tree *root, char *name) {
	
	tree *current;
	
	if (root == NULL)
		return root;
	
	current = root;
	
	while(1) {
		
		if ((strcmp(current->name, name)) == 0) {
			return current;
			break;
		}
		else if ((strcmp(current->name, name)) < 0) { 
			current = current->left;
		}
		else if ((strcmp(current->name, name)) > 0) {
			current = current->right;
		}
		else if (current == NULL) {
			printf("no such element in the tree\n");
			return root;
			break;
		}
	}
}

tree 
*apply_in_order (tree *root, void (*fn) (tree *root, void *), void *arg) {
	
	if (root == NULL)
		return root;	
	apply_in_order (root->left, fn, arg);
	fn(root, arg);
	apply_in_order (root->right, fn, arg);
	fn(root, arg);
}

